/*
 * ActionServlet.java
 *
 * Created on 31. říjen 2005, 14:54
 */

package cz.muni.fi.pa165.addressbook.web;

import cz.muni.fi.pa165.addressbook.AddressBook;
import cz.muni.fi.pa165.addressbook.Person;
import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;
/**
 *
 * @author xadamek2
 * @version
 */
public class ActionServlet extends HttpServlet {
    
    private AddressBook getAddressBook() {
	// tise predpokladame, ze jiz byla spustena stranka index jsp
	// a ze tudiz byl jiz addressBookBean vytvoren
	return (AddressBook) getServletContext().getAttribute("addressBookBean");
    }
    
    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {	
	String action = request.getParameter("action");
	
	if ("newPerson".equals(action)) {
	    request.setAttribute("person",new Person());
	    request.getRequestDispatcher("/editPerson.jsp").forward(request,response);
	} else if ("editPerson".equals(action)) {
	    // Tohle je obecně docela ošklivá věc - controller chystá data pro view
	    // nicméně v tomto případě jde o nejjdednodušší způsob jak zbytečně
	    // nekomplikovat view scripletem pro získání dat ...
	    request.setAttribute("person",getAddressBook().
		getPerson(Integer.valueOf(request.getParameter("id"))));
	    request.getRequestDispatcher("/editPerson.jsp").forward(request,response);
	} else if ("storePerson".equals(action)) {
	    String id = request.getParameter("id");
	        if(id.length() == 0) {
		    getAddressBook().newPerson(
			request.getParameter("name"),
			request.getParameter("address"));
		} else {
		    getAddressBook().updatePerson(
			Integer.valueOf(id),
			request.getParameter("name"),
			request.getParameter("address"));
		}
		request.getRequestDispatcher("/index.jsp").forward(request,response);
	} else {
	    throw new ServletException("Unknown action:" + action);
	}

    }
    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
	processRequest(request, response);
    }
    
    /** Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
	processRequest(request, response);
    }
    
    /** Returns a short description of the servlet.
     */
    public String getServletInfo() {
	return "Short description";
    }
    // </editor-fold>
}
